'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TreeNode = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _File = require('./File.js');

var _Folder = require('./Folder.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TreeNode = function (_React$Component) {
  _inherits(TreeNode, _React$Component);

  function TreeNode(props) {
    _classCallCheck(this, TreeNode);

    var _this = _possibleConstructorReturn(this, (TreeNode.__proto__ || Object.getPrototypeOf(TreeNode)).call(this, props));

    _this.state = {
      open: true
    };

    _this.toggleFolder = _this.toggleFolder.bind(_this);
    return _this;
  }

  _createClass(TreeNode, [{
    key: 'toggleFolder',
    value: function toggleFolder() {
      this.setState({
        open: !this.state.open
      });
    }
  }, {
    key: 'render',
    value: function render() {
      if (this.props.children) {
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(_Folder.Folder, {
            name: this.props.name,
            open: this.state.open,
            toggleFolder: this.toggleFolder
          }),
          this.state.open && _react2.default.createElement(
            'div',
            { style: { padding: '0 0 0 8px' } },
            this.props.children.map(function (child) {
              return _react2.default.createElement(TreeNode, {
                key: child.id,
                id: child.id,
                name: child.name,
                icon: child.icon,
                children: child.children,
                action: child.action
              });
            })
          )
        );
      } else {
        return _react2.default.createElement(_File.File, {
          id: this.props.id,
          name: this.props.name,
          icon: this.props.icon,
          action: this.props.action
        });
      }
    }
  }]);

  return TreeNode;
}(_react2.default.Component);

TreeNode.propTypes = {
  id: _propTypes2.default.string.isRequired,
  name: _propTypes2.default.string.isRequired,
  icon: _propTypes2.default.string,
  children: _propTypes2.default.array,
  action: _propTypes2.default.func
};

exports.TreeNode = TreeNode;